//----------------------------------------------------------------------------
// SLockLbl.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: SLockLbl.pas
//----------------------------------------------------------------------------
#ifndef SLockLblHPP
#define SLockLblHPP
//----------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <StdCtrls.hpp>
#include <ComCtrls.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Mask.hpp>
#include <Messages.hpp>
#include <Graphics.hpp>
#include <DsgnIntf.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Windows.hpp>
#include <System.hpp>
namespace Slocklbl
{
//-- type declarations -------------------------------------------------------
enum TLockPos { lpCustom, lpLeftTop, lpLeftCenter, lpLeftBottom, lpRightTop, lpRightCenter, lpRightBottom, 
	lpTopLeft, lpTopCenter, lpTopRight, lpBottomLeft, lpBottomCenter, lpBottomRight };

class __declspec(delphiclass) TFocusOptions;
class __declspec(delphiclass) TSLockLabel;
class __declspec(pascalimplementation) TSLockLabel : public Stdctrls::TLabel
{
	typedef Stdctrls::TLabel inherited;
	
private:
	TLockPos FLockPos;
	int FMargin;
	bool FAddColon;
	bool FLocked;
	bool FDestroy;
	void *FFocusInstance;
	void *FDefParentProc;
	TFocusOptions* FFocusOptions;
	Windows::TRect OldRect;
	bool FLockRunTime;
	bool Redoing;
	bool FDisabled;
	bool FFocused;
	Graphics::TColor FDisabledColor;
	Word FInstanceCount;
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	
protected:
	__fastcall virtual TSLockLabel(Classes::TComponent* Aowner);
	__fastcall virtual ~TSLockLabel(void);
	virtual void __fastcall Loaded(void);
	virtual void __fastcall Invalidate(void);
	void __fastcall DoAlign(void);
	void __fastcall ParentWndProc(Messages::TMessage &Message);
	void __fastcall SetLocked(bool Value);
	void __fastcall SubClass(bool Msg);
	void __fastcall UndoSubClass(void);
	HIDESBASE void __fastcall SetFocusControl(Controls::TWinControl* AControl);
	Controls::TWinControl* __fastcall GetFocusControl(void);
	void __fastcall SetLockPos(TLockPos AControl);
	void __fastcall SetMargin(int Value);
	HIDESBASE MESSAGE void __fastcall CMColorChanged(Messages::TMessage &Msg);
	void __fastcall SetAddColon(bool Value);
	void __fastcall SetCaption( System::AnsiString Value);
	virtual void __fastcall CheckCaption(void);
	System::AnsiString __fastcall GetCaption(void);
	void __fastcall SetDisabled(bool Value);
	void __fastcall SetDisabledColor(Graphics::TColor AColor);
	void __fastcall SetFocused(bool Value);
	void __fastcall SetFocusOptions(TFocusOptions* Value);
	
public:
	__property bool Disabled = {read=FDisabled, write=SetDisabled, nodefault};
	
__published:
	__property bool AddColon = {read=FAddColon, write=SetAddColon, default=1};
	__property System::AnsiString Caption = {read=GetCaption, write=SetCaption, nodefault};
	__property bool Locked = {read=FLocked, write=SetLocked, nodefault};
	__property Controls::TWinControl* FocusControl = {read=GetFocusControl, write=SetFocusControl, nodefault
		};
	__property TLockPos LockPosition = {read=FLockPos, write=SetLockPos, default=2};
	__property int LockMargin = {read=FMargin, write=SetMargin, nodefault};
	__property bool LockRunTime = {read=FLockRunTime, write=FLockRunTime, nodefault};
	__property Graphics::TColor DisabledColor = {read=FDisabledColor, write=SetDisabledColor, default=-2147483632
		};
	__property TFocusOptions* FocusOptions = {read=FFocusOptions, write=SetFocusOptions, nodefault};
};

class __declspec(pascalimplementation) TFocusOptions : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	TSLockLabel* FOwner;
	bool FFCAllowChange;
	Graphics::TColor FFCBackColor;
	Graphics::TColor FFCFontColor;
	Graphics::TColor FFCKeepbkColor;
	Graphics::TColor FFCKeepColor;
	Graphics::TColor FFontColor;
	Graphics::TColor FKeepColor;
	Graphics::TFontStyles FFCFontStyle;
	Graphics::TFontStyles FFCKeepStyle;
	Graphics::TFontStyles FFontStyle;
	Graphics::TFontStyles FKeepStyle;
	void __fastcall SetFCAllowChange(bool Value);
	void __fastcall SetFCBackColor(Graphics::TColor AColor);
	void __fastcall SetFCFontColor(Graphics::TColor AColor);
	void __fastcall SetFCFontStyle(Graphics::TFontStyles AStyle);
	void __fastcall SetFontColor(Graphics::TColor AColor);
	void __fastcall SetFontStyle(Graphics::TFontStyles AStyle);
	
public:
	__fastcall TFocusOptions(TSLockLabel* AOwner);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property bool FCAllowChange = {read=FFCAllowChange, write=SetFCAllowChange, nodefault};
	__property Graphics::TColor FCBackColor = {read=FFCBackColor, write=SetFCBackColor, default=65535};
		
	__property Graphics::TColor FCFontColor = {read=FFCFontColor, write=SetFCFontColor, default=-2147483640
		};
	__property Graphics::TFontStyles FCFontStyle = {read=FFCFontStyle, write=SetFCFontStyle, nodefault}
		;
	__property Graphics::TColor FontColor = {read=FFontColor, write=SetFontColor, nodefault};
	__property Graphics::TFontStyles FontStyle = {read=FFontStyle, write=SetFontStyle, nodefault};
public:
		
	/* TObject.Destroy */ __fastcall virtual ~TFocusOptions(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
#define CompID "Super Lock Label - v1.2"
#define DefLockMargin (Byte)(5)
#define DefDisabledColor (int)(-2147483632)
#define DefFontStyle 0x1
#define DefFCBackColor (int)(65535)
#define DefFCFontColor (int)(-2147483640)
#define DefLockPos (TLockPos)(2)
extern System::SmallString<4>  LabelPrefix;
extern void __fastcall Register(void);
//-- template instantiations -------------------------------------------------
template class SmallString<4> ;
template class Graphics::TFontStyles ;

}	/* namespace Slocklbl */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Slocklbl;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// SLockLbl
